//+------------------------------------------------------------------+
//|                                                 RD_CustInd_1.mq4 |

//+------------------------------------------------------------------+


#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Aqua   //up
#property indicator_color2 HotPink        //down
#property indicator_color3 Yellow      //MA

//---- input parameters
extern int barsToProcess = 10000;
extern int MA_Period = 20; //This value sets the Period for the Moving Average (Exponential)
extern int MA_Type = 1;   //0=SMA, 1=EMA
extern int MA_Price = 0;   //0=PRICE_CLOSE
extern double chartPeriod = 0;
extern string symbol = "none";
extern bool      WriteLog       = false;     // true - writes log
extern bool      WriteDebugLog  = false;     // true - writes debug log

double MA_;
double MA_1;
double MA_2;
double MA_LINE[];
double ArrowUp[];
double ArrowDown[];
string LastArrow[];
static int digits;
static double point;
static double apos;
double pVar;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  if( chartPeriod == 0)
      chartPeriod = Period();
  
  if( symbol == "none")
      symbol = Symbol();
    
    //if(WriteLog || WriteDebugLog) Print("*** symbol(indicator): ",symbol," ***");
    //if(WriteLog || WriteDebugLog) Print("*** chartPeriod(indicator): ",chartPeriod," ***");
      
   if(Digits < 4)
   {
      point = 0.01;
      digits = 2;
      pVar = ipm(chartPeriod);
     
      apos = point*pVar;      //20;
      //Print("Period is ", Period());

   }
   else
   {
      point = 0.0001;
      digits = 4;
      pVar = ipm(chartPeriod);
      //Print("Period is ", Period());

      apos = point*pVar;      //20;
   }  
   
   //---- indicator buffers mapping  
   SetIndexBuffer(0, ArrowUp);
   SetIndexBuffer(1, ArrowDown);  
   SetIndexBuffer(2, MA_LINE); 
   //---- indicators
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);        //225
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);        //226
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2);
   //SetIndexDrawBegin(2,MA_LINE);

//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Time Frame Determination                                         |
//+------------------------------------------------------------------+
  
int ipm(double p)      //indicatorPositionMultiplier
{
   if (p == PERIOD_M1 ) return (5);
   if (p == PERIOD_M5 ) return (10);
   if (p == PERIOD_M15) return (20);
   if (p == PERIOD_M30) return (20);
   if (p == PERIOD_H1 ) return (20);
   if (p == PERIOD_H4 ) return (30);
   if (p == PERIOD_D1 ) return (200);
   if (p == PERIOD_W1 ) return (400);
   if (p == PERIOD_MN1) return (800);
}
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   int i;
   int i1;
   int i2;   
   int limit;
   if(counted_bars < 0)
   return(-1);
   if(counted_bars > 0)
   counted_bars--;
   limit = Bars - counted_bars;

   if(limit > barsToProcess)
      limit = barsToProcess;

   for(i=0; i<=limit; i++)
   {
    SetIndexDrawBegin(2,i);
    
    i1 = i+1;
    i2 = i+2;    
    MA_ = iMA(symbol,0,MA_Period,0,MA_Type,MA_Price,i);
    MA_1 = iMA(symbol,0,MA_Period,0,MA_Type,MA_Price,i1);
    MA_2 = iMA(symbol,0,MA_Period,0,MA_Type,MA_Price,i2);
    MA_LINE[i] = MA_;
    //MA1_ = iMA(Symbol(),0,MA_Period,0,MA_Type,PRICE_CLOSE,i);

      /*------ Potential Buy */
      if( MA_1 >= Open[i1] && MA_1 < Close[i1] ){
      /*if( (MA_ <= Open[i]) && (MA_ <= Close[i]) && (Open[i] < Close[i]) )     
      {
        if( (MA_1 >= Open[i1] && MA_1 <= Close[i1]) || (MA_1 <= Open[i1] && MA_1 <= Close[i1]) )
        {
           if( (Close[i2] > Open[i2]) && (MA_2 >= Close[i2]) )
           {*/
               if(i>0){
                  if(LastArrow[i-1] == "down")
                     ArrowUp[i] = Low[i] - apos;
                  if(LastArrow[i-1] == "up")
                     ArrowUp[i] = 0; 
                  else
                     ArrowUp[i] = Low[i] - apos;                   
               }
               else  
                  ArrowUp[i] = Low[i] - apos;
                  
                  LastArrow[i] = "up";
           /*}
        }*/
      }     
      /*------ Potential Sell */
      if( MA_1 <= Open[i1] && MA_1 > Close[i1] ){
      /*if( (MA_ >= Open[i]) && (MA_ >= Close[i]) && (Open[i] > Close[i]) )     
      {
        if( (MA_1 <= Open[i1] && MA_1 > Close[i1]) || (MA_1 >= Open[i1] && MA_1 >= Close[i1]) )
         {
            if( (Close[i2] < Open[i2]) && (MA_2 <= Close[i2]) )
            {*/
                 
                if(i>0){
                  if(LastArrow[i-1] == "up")
                     ArrowDown[i] = High[i] + apos;
                  if(LastArrow[i-1] == "down")
                     ArrowDown[i] = 0;
                  else
                     ArrowDown[i] = High[i] + apos;
                }
                else
                   ArrowDown[i] = High[i] - apos;
                         
                  LastArrow[i] = "down";
            /*}
         }*/
      }

 
   }//end for loop
   
//----
   return(0);
  }
//+------------------------------------------------------------------+